﻿using System;
using System.Windows;

using DevExpress.Xpf.Grid;

namespace TestProject
{
    /// <summary>
    /// 메인 윈도우
    /// </summary>
    public partial class MainWindow : Window
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainWindow()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();

            this.gridControl.ItemsSource = TaskList.GetData();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 테이블 뷰 행 검증하기 - tableView_ValidateRow(sender, e)

        /// <summary>
        /// 테이블 뷰 행 검증하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void tableView_ValidateRow(object sender, GridRowValidationEventArgs e)
        {
            DateTime startDate = (e.Row as Task).StartDate;
            DateTime endDate   = (e.Row as Task).EndDate;

            e.IsValid = startDate < endDate;
        }

        #endregion
        #region 테이블 뷰 적절치 못한 행 예외 처리하기 - tableView_InvalidRowException(sender, e)

        /// <summary>
        /// 테이블 뷰 적절치 못한 행 예외 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void tableView_InvalidRowException(object sender, InvalidRowExceptionEventArgs e)
        {
            e.ExceptionMode = ExceptionMode.NoAction;
        }

        #endregion
    }
}